GlueGen: com.jogamp.gluegen.cgram.types.UnionType Class Reference

GlueGen v2.6.0-rc-20250822 GlueGen, Native Binding Generator for Java™ (public API).

Public Member Functions | List of all members
com.jogamp.gluegen.cgram.types.UnionType Class Reference
Inheritance diagram for com.jogamp.gluegen.cgram.types.UnionType:
Collaboration diagram for com.jogamp.gluegen.cgram.types.UnionType:

## Public Member Functions

final boolean | isStruct ()
| Indicates whether this type was declared as a struct. More...
final boolean | isUnion ()
| Indicates whether this type was declared as a union. More...
Public Member Functions inherited from com.jogamp.gluegen.cgram.types.CompoundType
void | rename (final String newName)
| Rename this symbol with the given `newName` if not equal `current-name`. More...
void | addAliasedName (final String origName)
| Add the given `origName` to the list of `aliases` if not equal `current-name`. More...
boolean | hasAliases ()
| Returns `true` if this symbol has aliases, i.e. More...
Set< String > | getAliasedNames ()
| Return all aliases for this symbol, i.e. More...
String | getAliasedString ()
| Return this object's `toString()` wrapped w/ the `current-name` and all `aliases`. More...
String | getOrigName ()
| Return the original-name as set at creation. More...
String | getStructName ()
| Returns the struct name of this CompoundType, i.e. More...
CompoundType | asCompound ()
| Casts this to a CompoundType or returns null if not a CompoundType. More...
String | getCName (final boolean includeCVAttrs)
| Returns the name of this type, optionally including const/volatile attributes. More...
int | getNumFields ()
| Returns the number of fields in this type. More...
Field | getField (final int i)
| Returns the ith field of this type. More...
Field | getField (final String name)
| Returns the name matching field of this type. More...
void | addField (final Field f)
| Adds a field to this type. More...
void | setBodyParsed () throws IllegalStateException
| Indicates to this CompoundType that its body has been parsed and that no more `addField` operations will be made. More...
abstract boolean | isStruct ()
| Indicates whether this type was declared as a struct. More...
abstract boolean | isUnion ()
| Indicates whether this type was declared as a union. More...
String | toString ()
| Returns a string representation of this type. More...
void | visit (final TypeVisitor arg)
| Traverse this `Type` and all of its component types; for example, the return type and argument types of a FunctionType. More...
String | getStructString ()
Public Member Functions inherited from com.jogamp.gluegen.cgram.types.MemoryLayoutType
boolean | isLayouted ()
void | setLayouted ()
Public Member Functions inherited from com.jogamp.gluegen.cgram.types.Type
final Type | newCVVariant (final int cvAttributes)
| Return a variant of this type matching the given const/volatile attributes. More...
Type | clone (final ASTLocusTag newLoc)
| Clones this instance using a new `ASTLocusTag`. More...
final ASTLocusTag | getASTLocusTag ()
| Returns this instance's `ASTLocusTag`, if available, otherwise returns `null`. More...
boolean | isAnon ()
final String | getCName ()
| Returns the name of this type. More...
String | getCName (final boolean includeCVAttrs)
| Returns the name of this type, optionally including const/volatile attributes. More...
final String | getName ()
| Returns the name of this type. More...
String | getName (final boolean includeCVAttrs)
| Returns the name of this type, optionally including const/volatile attributes. More...
String | toString ()
| Returns a string representation of this type. More...
final StringBuilder | getSignature (StringBuilder sb)
final String | getDebugString ()
boolean | setTypedefName (final String name)
| Set the typedef name of this type and renders this type a typedef, if given `name` has a length. More...
final boolean | isTypedef ()
| Indicates whether this type is a typedef type, i.e. More...
final boolean | hasSize ()
| Returns true if `getSize()` is not null, otherwise false. More...
final SizeThunk | getSize ()
| SizeThunk which computes size of this type in bytes. More...
final long | getSize (final MachineDataInfo machDesc)
| Size of this type in bytes according to the given MachineDataInfo. More...
BitType | asBit ()
| Casts this to a BitType or returns null if not a BitType. More...
IntType | asInt ()
| Casts this to an IntType or returns null if not an IntType. More...
EnumType | asEnum ()
| Casts this to an EnumType or returns null if not an EnumType. More...
FloatType | asFloat ()
| Casts this to a FloatType or returns null if not a FloatType. More...
DoubleType | asDouble ()
| Casts this to a DoubleType or returns null if not a DoubleType. More...
PointerType | asPointer ()
| Casts this to a PointerType or returns null if not a PointerType. More...
ArrayType | asArray ()
| Casts this to an ArrayType or returns null if not an ArrayType. More...
CompoundType | asCompound ()
| Casts this to a CompoundType or returns null if not a CompoundType. More...
FunctionType | asFunction ()
| Casts this to a FunctionType or returns null if not a FunctionType. More...
VoidType | asVoid ()
| Casts this to a VoidType or returns null if not a VoidType. More...
final boolean | isBit ()
| Indicates whether this is a BitType. More...
final boolean | isInt ()
| Indicates whether this is an IntType. More...
final boolean | isEnum ()
| Indicates whether this is an EnumType. More...
final boolean | isFloat ()
| Indicates whether this is a FloatType. More...
final boolean | isDouble ()
| Indicates whether this is a DoubleType. More...
final boolean | isPointer ()
| Indicates whether this is a PointerType. More...
final boolean | isArray ()
| Indicates whether this is an ArrayType. More...
final boolean | isCompound ()
| Indicates whether this is a CompoundType. More...
final boolean | isFunction ()
| Indicates whether this is a FunctionType. More...
final boolean | isVoid ()
| Indicates whether this is a VoidType. More...
final boolean | isVolatile ()
| Indicates whether this type is volatile. More...
final boolean | isConst ()
| Indicates whether this type is const. More...
boolean | isPrimitive ()
| Indicates whether this type is a primitive type. More...
boolean | isFunctionPointer ()
| Convenience routine indicating whether this Type is a pointer to a function. More...
final boolean | isBaseTypeConst ()
| Checks the base type of pointer-to-pointer, pointer, array or plain for const-ness. More...
final int | hashCode ()
| Hashcode for Types. More...
final boolean | equals (final Object arg)
| Equality test for Types inclusive its given `name`. More...
final int | hashCodeSemantics ()
| Semantic hashcode for Types exclusive its given `name`. More...
final boolean | equalSemantics (final SemanticEqualityOp arg)
| Semantic equality test for Types exclusive its given `name`. More...
void | visit (final TypeVisitor visitor)
| Traverse this `Type` and all of its component types; for example, the return type and argument types of a FunctionType. More...
final int | getCVAttributes ()
final String | getCVAttributesString ()
| Returns a string indicating the const/volatile attributes of this type. More...
int | pointerDepth ()
| Helper method for determining how many pointer indirections this type represents (i.e., "void **" returns 2). More...
int | arrayDimension ()
| Helper method for determining how many array dimentions this type represents (i.e., "char[][]" returns 2). More...
Type | getBaseType ()
| Helper method to returns the bottom-most element type of this type, i.e. More...
Type | getTargetType ()
| Helper method to returns the target type of this type, in case another type is being referenced, i.e. More...
Type | getArrayBaseOrPointerTargetType ()
| Return `getBaseType()` if `isArray()` or returns `getTargetType()` otherwise. More...
FunctionType | getTargetFunction ()
| Returns the target `FunctionType` if this type is `isFunctionPointer()`. More...
int | hashCodeSemantics ()
| Semantic hashcode for Types exclusive its given `name`. More...
boolean | equalSemantics (final SemanticEqualityOp arg)
| Semantic equality test for Types exclusive its given `name`. More...
ASTLocusTag | getASTLocusTag ()
| Returns this instance's `ASTLocusTag`, if available, otherwise returns `null`. More...
Public Member Functions inherited from com.jogamp.gluegen.cgram.types.AliasedSymbol
void | rename (final String newName)
| Rename this symbol with the given `newName` if not equal `current-name`. More...
void | addAliasedName (final String origName)
| Add the given `origName` to the list of `aliases` if not equal `current-name`. More...
boolean | hasAliases ()
| Returns `true` if this symbol has aliases, i.e. More...
Set< String > | getAliasedNames ()
| Return all aliases for this symbol, i.e. More...
String | getOrigName ()
| Return the original-name as set at creation. More...
String | getName ()
| Return the current-name, which is the last `renamed-name` if issued, or the `original-name`. More...
String | getAliasedString ()
| Return this object's `toString()` wrapped w/ the `current-name` and all `aliases`. More...

## Additional Inherited Members

Static Public Member Functions inherited from com.jogamp.gluegen.cgram.types.CompoundType
static CompoundType | create (final String structName, final SizeThunk size, final CompoundTypeKind kind, final int cvAttributes, final ASTLocusTag astLocus)
Public Attributes inherited from com.jogamp.gluegen.cgram.types.Type
final boolean | relaxedEqSem
Protected Member Functions inherited from com.jogamp.gluegen.cgram.types.CompoundType
int | hashCodeImpl ()
boolean | equalsImpl (final Type arg)
int | hashCodeSemanticsImpl ()
boolean | equalSemanticsImpl (final Type arg)
Protected Member Functions inherited from com.jogamp.gluegen.cgram.types.MemoryLayoutType
| MemoryLayoutType (final String name, final SizeThunk size, final int cvAttributes, final ASTLocusTag astLocus)
Protected Member Functions inherited from com.jogamp.gluegen.cgram.types.Type
| Type (final String name, final SizeThunk size, final int cvAttributes, final ASTLocusTag astLocus)
final void | clearCache ()
abstract int | hashCodeImpl ()
abstract boolean | equalsImpl (final Type t)
abstract int | hashCodeSemanticsImpl ()
abstract boolean | equalSemanticsImpl (final Type t)

## Detailed Description

Definition at line 32 of file UnionType.java.

## Member Function Documentation

## ◆ isStruct()

final boolean com.jogamp.gluegen.cgram.types.UnionType.isStruct | ( |  | ) |

Indicates whether this type was declared as a struct.

Reimplemented from com.jogamp.gluegen.cgram.types.CompoundType.

Definition at line 48 of file UnionType.java.

## ◆ isUnion()

final boolean com.jogamp.gluegen.cgram.types.UnionType.isUnion | ( |  | ) |

Indicates whether this type was declared as a union.

Reimplemented from com.jogamp.gluegen.cgram.types.CompoundType.

Definition at line 50 of file UnionType.java.

The documentation for this class was generated from the following file:

- src/java/com/jogamp/gluegen/cgram/types/UnionType.java